package files

import (
	"testing"

	"git.perx.ru/perxis/perxis-go/pkg/schema"
	"git.perx.ru/perxis/perxis-go/pkg/schema/field"
	"github.com/stretchr/testify/assert"
)

func TestFileField_Get(t *testing.T) {
	sch := schema.New(
		"a", field.String(),
		"b", field.Object(
			"file", Field(),
		),
		"file", Field(),
	)
	sch.ClearState()

	assert.Equal(t, field.String(), sch.GetField("file.id"))
	assert.Equal(t, field.String(), sch.GetField("file.name"))
	assert.Equal(t, field.String(), sch.GetField("file.mimeType"))
	assert.Equal(t, field.String(), sch.GetField("file.url"))
	assert.Equal(t, field.String(), sch.GetField("file.key"))
	assert.Equal(t, field.Number(field.NumberFormatInt), sch.GetField("file.size"))

	assert.Equal(t, field.String(), sch.GetField("b.file.id"))
	assert.Equal(t, field.String(), sch.GetField("b.file.name"))
	assert.Equal(t, field.String(), sch.GetField("b.file.mimeType"))
	assert.Equal(t, field.String(), sch.GetField("b.file.url"))
	assert.Equal(t, field.String(), sch.GetField("b.file.key"))
	assert.Equal(t, field.Number(field.NumberFormatInt), sch.GetField("b.file.size"))
}
